;=========================
;     ZX-Assembler-2 
;  by Artic Computing LTD
;=========================

ORG 4084

;=========================
;Jump table 
;=========================

	JR Wallpaper		;16516, Fill display with wallpaper character.
	JR Bank2		;16518, Compliment the Bank 2 characters.
	JR Bank1		;16520, Compliment the Bank 1 & 2 characters
	JP RandomSet		;16522, Fill random no. table.
	JP SetUDGs		;16524, Set custom UDG characters.
	00 00 00
	00 00 00
	00 00

;=========================
;Print A$ 
;
;$ Code=Chr Code + 32
;A$=38+32=70
;=========================
@FindA
	LD C,46			;C=A$ CODE
	LD DE,(4010)		;HL=start of VARS
@NextVar
	EX DE,HL
	LD A,(HL) 		;Find A$
	CP C			;A$?
	JR Z AString 		;A$ FOUND
	CP 80 			;End of VARS?
	JP Z 0D4B		;REPORT-2, Variable (A$) not found
	PUSH BC			;Save A$ code
	CALL 09F2		;The "Next line or variable' subroutine
	POP BC			;C=A$ CODE 
	JR NextVar
@AString
	INC HL			;A$ header info
	LD C,(HL)
	INC HL
	LD B,(HL)	 	;BC=Length of A$
	INC HL			;HL=Start of A$ text section
@PrntAstr
	PUSH HL			;PUSH A$ text address
	PUSH BC			;PUSH A$ counter
	LD A,(HL)		;Print character via RST 10
@Quote
	CP C0
	JR NZ NotQuote
	LD A,0B
@NotQuote
	RST 10
	LD BC,FFFF		;Typermatic delay, POKE HERE
@DLay
	DEC BC			;Decrease counter
	LD A,B
	OR C 
	JR NZ DLay
	POP BC			;POP A$ counter
	POP HL			;POP A$ address
	INC HL			;Next chr. to print
	DEC BC			;Decrease counter
	LD A,B 
	OR C 
	JR NZ PrntAstr		;Loop until all chr. printed
	RET
;==================================
;Set wallpaper
;==================================
@Wallpaper
	LD DE,(+16444)		;(PRBUFF), Replace Chr. D with Chr. E
	LD B,18 
@Rep2
	LD HL,(400C)		;Get D-FILE
@Loop
	INC HL 
	LD A,(HL) 
	CP 76 			;Skip N/L Chr.
	JR Z SkipNL
	LD (HL),E
	JR Loop
@SkipNL
	DJNZ Loop
	RET
;==================================
;Invert Bank 2
;==================================
@Bank2
	LD HL,2200		;Start of Bank 2
	JR InvNext
;==================================
;Invert Bank 1 & 2
;==================================
@Bank1
	LD HL,2000		;UDG characters
@InvNext
	LD A,(HL)
	CPL
 	LD  (HL),A
	INC HL
	LD A,24
	CP H
	JR NZ InvNext		;If NZ do next BYTE
	RET
;=======================================
;Generate random number between 1 and 100
;=======================================
@RNDNum
	LD HL,(4032)		;(SEED) 
	LD D,H		
	LD E,L
	ADD HL,HL
	ADD HL,HL
	ADD HL,DE
	ADD HL,HL
	ADD HL,HL
	ADD HL,HL
	ADD HL,DE
	LD (4032),HL		;The new random number seed is stored, (SEED) 
	LD A,H			;A=0 to 99
	CP 64
	JR NC RNDNum
	INC A			;A=1 to 100
	RET
;=======================================
;Fill table with random, non-repeating,
;numbers.
;=======================================
@RandomSet
	LD HL,RNDNos		;Clear the table
	LD (HL),00
	LD D,H
	LD E,L
	INC DE
	LD BC,0064
	LDIR
	LD HL,(4034)		;Get (FRAMES)
	LD (4032),HL		;RAND 0
@RandGen
	CALL RNDNum
	LD C,64
	LD D,C
	LD E,A
	LD HL,RNDNos
	XOR A
	CPIR
	RET PO			;Table is full
	DEC HL			;Empty Slot
	PUSH HL
	LD HL,RNDNos
	LD A,E			;Search for number
	LD C,D
	CPIR
	POP HL			;Empty slot
	JR Z RandGen		;Number already in table
	LD (HL),E
	JR RandGen
;=======================================
;Set UDG characters
;=======================================
@SetUDGs
	LD DE,2090		;> and <
	LD HL,UDGs		;UDG patterns
	LD BC,0010		;Bytes to move
	LDIR
	LD DE,20B8		;*
	LD C,08			;Bytes to move
	LDIR
	LD DE,2058		;Generic quote
	LD C,08			;Bytes to move
	LDIR
	RET
@RNDNos
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00 
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00 
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00
	00 00 00 00 00 00 00 00
@UDGs
	FF 00 00 00 00 00 00 00	;>=Underline
	00 00 00 00 00 00 00 FF	;<=Underscore
	00 00 FF FF 7E 3C 18 18	;*=Down pointer
	00 24 24 00 00 00 00 00	;Generic quote mark

