;==========================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;==========================

ORG 5014

@DFILE=400C		;Start of D-FILE
@VARS=4010
@SWAP=403C		;Stored SWAP characters
@COUNT=403E		;Stored FLASH counter
@SEED=4032
;==================================
;Flash the screen
;==================================
@FLASH
	LD HL,COUNT	;Flash counter address
	LD BC,0100
	LD DE,(SWAP)	;Replace Chr. D with Chr. E
	LD A,(HL)
	CP C
	JR Z REP2	;IF Z then no FLASH
	LD B,(HL)	;Flash counter
@FLSH
	PUSH BC		;Flash Counter
	PUSH DE		;DE=Chr. pair to SWAP
	CALL REPLACE	;Replace Chr. D with Chr. E
	LD HL,(SWAP)	;Switch Chrs
	LD D,L		;DE=Chr. pair to SWAP
	LD E,H
	CALL REPLACE	;Replace Chr. D with Chr. E
	POP DE		;Chr. pair 1
	POP BC		;Flash Counter
	DJNZ FLSH
	RET
;==================================
;Replace CHR D with CHR E
;==================================
@REPLACE
	LD B,18 
@REP2
	LD HL,(DFILE)	;Get D-FILE
@NEXT
	INC HL 
	LD A,(HL) 
	CP 76 		;Skip N/L Chr.
	JR Z SKIPNL
	CP D 		;Find this Chr.
	JR NZ NEXT
	LD (HL),E
	JR NEXT
@SKIPNL
	DJNZ NEXT
	RET
;==================================
;Scroll Down
;==================================
@DScroll
	LD HL,(VARS)
	DEC HL 
	PUSH HL 
	LD DE,0021 
	SBC HL,DE 
	POP DE 
	LD BC,02F7 
	LDDR 
	LD HL,(DFILE)
	LD B,20 
@DSLOOP
	INC HL 
	LD (HL),00 
	DJNZ DSLOOP
	RET
;==================================
;Swap CHR D with CHR E
;==================================
@SWAP
	LD DE,(SWAP)	;Replace Chr. D with Chr. E
	JR REPLACE
;==================================
;Fortress Hit
;==================================
@HIT
	LD A,1E
	LD I,A
	CALL FLASH
	LD A,21
	LD I,A
	RET
